	ORG $1001-2
	DW $1001
	
	DW $100B,0
	DB $9E,"4109",0,0,0
	
	include "!playerv.asm"

src	= $E0
temp	= $E2	
dest	= $E4
row	= $E6
	;
time		= $0F2D
max_raster	= time + 14
max_raster_chr	= time + 10
track_info	= $0F70
hexdump_dest = $2020

Print16	MACRO addr
	LDA #"$"
	JSR $FFD2
	LDA #addr >> 8
	JSR $FB10
	LDA #addr & 255
	JSR $FB10
	ENDM
	
start	;
;	JSR $FF4F
;	DB "DUMPING HEX",$0D,0
;	;
;	LDA #hexdump_dest & 255	; create data from $4000
;	STA dest
;	LDA #hexdump_dest >> 8
;	STA dest+1
;	;
;	LDA #$00
;	STA row
;	;
;	LDA #music_beg & 255	; start from music_beg
;	STA src
;	LDA #music_beg >> 8
;	STA src+1
;	;
;hloop	LDA src			; check if at music_end
;	CMP #music_end & 255
;	BNE ne1
;	LDA src+1
;	CMP #music_end >> 8
;	BEQ ne2
;ne1	;
;	LDA row
;	AND #$0F
;	BNE nodb
;	;
;	LDA #$09		; tab
;	JSR putb
;	LDA #"D"		; "DB " at beginning of rows
;	JSR putb
;	LDA #"B"
;	JSR putb
;	LDA #" "
;	JSR putb
;	;
;	JMP skipcm
;	;
;nodb	LDA #","
;	JSR putb
;	;
;skipcm	LDA #"$"		; "$"
;	JSR putb
;	;
;	LDY #$00		; high nibble
;	LDA (src),y
;	LSR a
;	LSR a
;	LSR a
;	LSR a
;	TAX
;	LDA hexchars,x
;	JSR putb
;	;
;	LDA (src),y		; low nibble
;	AND #$0F
;	TAX
;	LDA hexchars,x
;	JSR putb
;	;
;	LDA row			; comma or linebreak
;	AND #$0F
;	CMP #$0F
;	BNE nextb
;	;
;	JSR put_newline
;	;
;	; next byte
;	;
;nextb	INC row      
;	;
;	LDA src
;	CLC
;	ADC #$01
;	STA src
;	LDA src+1
;	ADC #$00
;	STA src+1
;	;
;	JMP hloop
;	;
;	; -------------------------------------------------
;	;
;ne2	JSR put_newline
;	;
;	JSR $FF4F
;	DB "SAVING TO DISK",$0D,0
;	;
;	LDA #hexdump_dest & 255	; save FROM
;	STA $F4
;	LDA #hexdump_dest >> 8
;	STA $F5
;	;
;	LDA #$01	; logical number
;	LDX #$08	; device number (8=disk)
;	LDY #$01	; secondary address
;	JSR $FFBA	; KERNAL: SETLFS
;	LDA #fname_end - fname
;	LDX #fname & 255
;	LDY #fname >> 8
;	JSR $FFBD	; KERNAL: SETNAM (Set length and filename address)
;	;
;	LDA #$F4	; A=zp address
;	LDX dest
;	LDY dest+1
;	JSR $FFD8	; KERNAL: SAVESP
	;
	; ------------------------------------------------
	;
	JSR $FF4F
	DB $93,$90
	DB $0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D
	DB $0D,$0D,$0D,$0D,$0D,$0D,$0D,$0D
	DB "TIME/RASTER: 00:00 ( ) 00 ( )",$0D,$90
	DB "MUSIC      : "
	;
	DB 0                          
	;       
	Print16 music_beg    
	JSR $FF4F
	DB " - ",0
	Print16 music_end
	;
	SEI
	;
	LDY #$00
reloc1	LDA $1800,y
	STA $0400,y
	LDA $1900,y
	STA $0500,y
	LDA $1A00,y
	STA $0600,y
	LDA $1B00,y
	STA $0700,y
	LDA $1C00,y
	STA $0800,y
	LDA $1D00,y
	STA $0900,y
	LDA $1E00,y
	STA $0A00,y
	LDA $1F00,y
	STA $0B00,y
	;
	INY
	BNE reloc1
	;
;	LDA #$18
;	STA dest+1
;	LDY #$00
;	STY dest
;cl2	LDA #$AA
;cl1	STA (dest),y
;	STY $FF19
;	INY
;	BNE cl1
;	;    
;	INC dest+1
;	LDA dest+1
;	CMP #$FD
;	BNE cl2
	;
	; ----------------
	;
	LDA #$00
	STA time+7
	STA max_raster
	;
	LDA #$41
	STA $FF19
	LDA #$51
	STA $FF15
	;
	JSR PLAYER_FREQ_INIT-OFS
	;
	; ---
	;        
	LDY #$00
	LDX #$00
delay	INX
	BNE delay
	INY
	BNE delay
	;
sync0	LDA $FF1D
	CMP #$40
	BNE sync0
	;
	DEC $FF19
	LDA $FF1D
	STA r_start+1
	;
	;JMP *
	JSR PLAYER-OFS
	;
vol_down
	LDA #$00
	BEQ no_vol_down
	;
vol_delay
	LDA #$00
	CLC
	ADC #$01
	AND #$0F
	STA vol_delay+1
	BNE no_vol_down
	;
	LDA VOLUME
	CLC
	ADC #$09
	CMP #21*9
	BNE do_vol_down
	JMP $FFF6
do_vol_down
	STA VOLUME
no_vol_down
	;
	INC $FF19
	;
	LDA $FF1D
	SEC
r_start	SBC #$00
	CMP max_raster
	BCC not_larger
	;
	STA max_raster
	;
	AND #$0F    
	TAX
	LDA hex_char,x
	STA max_raster_chr+1
	;
	LDA max_raster
	LSR a
	LSR a
	LSR a
	LSR a
	TAX
	LDA hex_char,x
	STA max_raster_chr
	;
not_larger
	;
	JSR INC_TIMER
	;
	JSR dump_track_info
	;
	;LDA $FF12
	;AND #$03
	;JSR $FB10
	;LDA $FF0E
	;JSR $FB10
	;LDA #$0D
	;JSR $FFD2
	;
kdelay	LDY #$00
	BEQ kcheck
	DEY 
	JMP kend
	
kcheck	LDA #$BF
	STA $FD30
	STA $FF08
	LDA $FF08
	CMP #$F7
	BNE x5
	;   
	LDA #$21
	STA $FF15
	STA vol_down+1
	; do something on keypress
	;
x5	;
	LDY #$04    
kend	STY kdelay+1
	;
	JMP sync0
	;
	
INC_TIMER
	LDA time+7
	CLC
	ADC #$01
	CMP #50
	BNE inc1     
	;
	LDX #$05
inc2	DEX 
	CPX #$02
	BEQ inc2
	LDA time,x
	CLC
	ADC #$01
	CMP time_end,x
	BNE inc3
	LDA #$30
inc3	STA time,x
	CMP #$30
	BEQ inc2
	;
	LDA #$00
inc1	STA time+7
	;
	RTS
time_end
	DB $3A,$3A,$3A,$36,$3A
hex_char
	DB "0123456789",1,2,3,4,5,6
	
hexchars
	DB "0123456789ABCDEF"
 
put_newline
	LDA #$0D
	JSR putb
	LDA #$0A
	;		
putb	STA $FF19
	STA (dest),y
	JMP add_dest_1
	
dump_track_info
	LDA #track_info & 255
	STA dest
	LDA #track_info >> 8
	STA dest+1
	;
	LDX #$00
dt2	STX x_save+1
	LDA CH1_LO,x
	STA temp
	LDA CH1_HI,x
	STA temp+1
	;
	LDX temp
	JSR write_word
	JSR add_dest_1
	;
	LDY #$00
dt1	LDA (temp),y
	JSR write_byte
	JSR add_dest_1
	INY
	CPY #$08
	BNE dt1     
	;
	LDA #$0B
	JSR add_dest
	;
x_save	LDX #$00
	INX
	CPX #$03
	BNE dt2
	;
	RTS           
	
write_word
	STX x_sav2+1
	JSR write_byte
x_sav2	LDA #$00
	;
write_byte
	STY y_save+1
	PHA
	LSR a
	LSR a
	LSR a
	LSR a         
	TAX
	LDA hex_char,x
	LDY #$00
	STA (dest),y
	PLA
	AND #$0F    
	TAX
	LDA hex_char,x
	INY
	STA (dest),y
	;
	LDA #$02
	JSR add_dest
y_save	LDY #$00
	RTS
	                 
add_dest_1	                
	LDA #$01         
add_dest
	CLC
	ADC dest
	STA dest
	BCC *+4
	INC dest+1
	RTS
	
fname
	DB "music_hex"
fname_end

OFS	= $1800 - $0400
	ORG $1800
music_beg
	include "!player_data.asm"
	include "!player.asm"
	include "!playerv.asm"
	include "music.asm"
music_end
